import React,{Component} from 'react';
import {View} from '@tarojs/components'
import {getUserByName} from '../../utils/servers/servers';

import {AtSearchBar, AtListItem} from 'taro-ui'

import 'taro-ui/dist/style/components/search-bar.scss';
import 'taro-ui/dist/style/components/button.scss';
import 'taro-ui/dist/style/components/icon.scss';
import 'taro-ui/dist/style/components/list.scss';
import 'taro-ui/dist/style/components/icon.scss';

import ListBottomStart from '../../components/common/listBottomStart';

import Taro from '@tarojs/taro';

class Enterprise extends Component{
  constructor(props) {
    super(props);
    this.state={
      value:'',
      loading:false,
      data:[],
      listState:'NO_DATA'
    }
    this.onChange = this.onChange.bind(this);
  }

  componentDidMount() {
    Taro.eventCenter.on('result', () => {
      this.setState({
        value:'',
        loading:false,
        data:[],
        listState:'NO_DATA'
      })
    })
  }

  onChange (value) {
    this.setState({
      value,
    })
    if(value.length < 4){return}
    this.setState({
      listState: 'LOADING'
    })
    getUserByName({
      name:value
    }).then((data)=>{
      if(data.error.length === 0){
        if(data.data.length === 0){
          this.setState({
            listState: 'NO_DATA'
          })
        }else{
          this.setState({
            listState: 'NO_MORE_DATA'
          })
        }
        this.setState({
          data:data.data
        })
      }else{
        this.setState({
          listState: data.error[0].field === '403' ? 'NO_DATA' : 'RELOAD'
        })
        Taro.showToast({
          title:data.error[0].message,
          icon:'none'
        })
      }
    }).catch(()=>{
      this.setState({
        listState: 'RELOAD'
      })
    })
  }

  render() {
    return (
      <>
        <AtSearchBar
          showActionButton
          value={this.state.value}
          onChange={this.onChange}
          onActionClick={()=>{this.onChange(this.state.value)}}
          onClear={()=>{
            this.setState({
              value:'',
              data:[],
              listState:'NO_DATA'
            })
          }}
        />
        <View>
          {
            this.state.data.map((v,k)=>(
              <View key={k}>
                <AtListItem
                  title={v.name}
                  arrow='right'
                  iconInfo={{ size: 25, color: '#000000', value: 'bookmark', }}
                  onClick={()=>{
                    Taro.eventCenter.trigger('enterprise', v)
                  }}
                />
              </View>
            ))
          }
          <ListBottomStart
            state={this.state.listState}
            reload={()=>{
              this.onChange(this.state.value)
            }}/>
        </View>
      </>
    )
  }
}

export default Enterprise;
